//+------------------------------------------------------------------+
//|                                                        |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, FX Sniper "
#property  link      "http://www.metaquotes.net/"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 7
#property indicator_color1 DeepSkyBlue
#property indicator_color2 SpringGreen
#property indicator_color3 Red
#property indicator_color4 DodgerBlue
#property indicator_color5 DeepPink
#property indicator_color6 DarkKhaki
#property indicator_color7 DarkKhaki
#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

//---- buffers
//support
double ArrowUp[];
double ArrowDn[];
double Trend[];
double TrendUp[];
double TrendDn[];
double ChannelUp[];
double ChannelDn[];

double coeff; 
extern double coeff0 = 0.5;
extern double coeff1 = 0.2;
extern double coeff2 = 0.1;
extern int n0 = 50;
extern int n1 = 150;

static int nl,nh;
extern int Nmax=15;
extern double Rmax=2.0;
extern double Mmax=5.0;

static int nup,ndn;
static double prevUp,prevDn;
extern int Length1 = 10;   //   

int Nstat=3000;
extern datetime D0=D'01.02.2009';
extern bool drawArrows = true;
extern bool drawChannel = true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3additional buffers are used for counting.
   
//---- drawing settings

   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3, ArrowUp);      
   SetIndexArrow(3, 233);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexBuffer(4, ArrowDn);      
   SetIndexArrow(4, 234);

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, Trend);      
   SetIndexLabel(0, "Trend");
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, TrendUp);      
   SetIndexLabel(1, "TrendUp");
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2, TrendDn);      
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5, ChannelUp);      
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6, ChannelDn);      

   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
   SetIndexEmptyValue(4,0);
   SetIndexEmptyValue(5,0);
   SetIndexEmptyValue(6,0);
   
   return(0);
  }

int deinit ()
  {
      Comment("");  
  }
int start()

  {
//      if (Bars-IndicatorCounted()<=1) return(0);

      if (IndicatorCounted() < 0) return(-1); 
      
      //  
      Nstat = iBarShift(NULL,0,D0);
      if (Nstat>Bars-10) Nstat -=11;
      
      int loopbegin;
      loopbegin = Nstat;
      
      double Brick, Up0, Dn0, BricksUp, BricksDn, lastB, lastS, Profit,K,norm;
      bool noBuy, noSell;
      
      noBuy = true;
      noSell = true;
      
      

      int i;
      static int dir = 0;
      static double h0,l0;
      double r,m; 
      
      // 
      if (Close[Nstat+10]<=Close[Nstat+1]) {
         l0=Close[Nstat+10];
         h0=Close[Nstat+1];
         dir=1;
         nl=Nstat+10;
         nh=Nstat+1;
      }
      if (Close[Nstat+10]>Close[Nstat+1]) {
         l0=Close[Nstat+1];
         h0=Close[Nstat+10];
         dir=-1;
         nl=Nstat+1;
         nh=Nstat+10;
      }
      nup=0;ndn=0;
      prevUp=Close[Nstat+10];
      prevDn=Close[Nstat+10];
      
      for(i = loopbegin; i >= 0; i--) {
         
         double ma = iMA(NULL,0,Length1,0,MODE_SMA,PRICE_CLOSE,i);
         Trend[i]=ma;
         // 
         //   
         //   buy
         if (dir>0&&i<Nstat&&Trend[i]>0) {
           // coeff
           if (nl-i<n0) {
             coeff=coeff0;
           } else if (nl-i<n1) {
             coeff=coeff1;
           } else {
             coeff=coeff2;
           }          
           double rev0=h0*(1-coeff)+l0*coeff; // 
           if (Trend[i]<rev0) { //    coeff - 
              dir = -1;
              l0 = Trend[i];
              nl=i;
           }
           if (Trend[i]>h0) { // 
              h0=Trend[i];
              nh=i;
           }
         }
         //   
         if (dir<0&&i<Nstat&&Trend[i]>0) { //   sell
           // coeff
           if (nh-i<n0) {
             coeff=coeff0;
           } else if (nh-i<n1) {
             coeff=coeff1;
           } else {
             coeff=coeff2;
           }          
           double rev1=l0*(1-coeff)+h0*coeff; // 
           if (Trend[i]>rev1) { //    coeff - 
              dir = 1;
              h0 = Trend[i];
              nh=i;
           }
           if (Trend[i]<l0) { // 
              l0=Trend[i];
              nl=i;
           }
         }
         // 
         if (dir>0) {       
            TrendUp[i]=Trend[i];
            TrendDn[i]=0;
         } else {
            TrendDn[i]=Trend[i];
            TrendUp[i]=0;
         }
         if(drawArrows) {
            double s0=iStdDev(NULL,0,Length1,0,MODE_SMA,PRICE_CLOSE,i);
            
            if (drawChannel) {
               ChannelUp[i] = Trend[i]+s0*Rmax;
               ChannelDn[i] = Trend[i]-s0*Rmax;
            }
            
            if (TrendUp[i+1]>0 && TrendDn[i+2]>0) {
               ArrowUp[i]=Open[i];
               nup=0;
               prevUp=Open[i];
            }
            if (TrendUp[i+2]>0 && TrendDn[i+1]>0) {
               ArrowDn[i]=Open[i];
               ndn=0;
               prevDn=Open[i];
            }
            if (TrendUp[i+1]>0 && TrendUp[i+2]>0 && nup<Nmax && TrendUp[i+1]>TrendUp[i+2] &&
                ArrowUp[i+1]==0 && ArrowUp[i+2]==0 && ArrowUp[i+3]==0) {
               
               //  
               m=(Open[i]-prevUp)/s0/Mmax;
               if (m<0) m=0;
               if (m>1) m=1;
               

               r=0.5+(-Open[i]+TrendUp[i+1])/s0/2.0/Rmax;
               if (r<0) r=0;
               if (r>1) r=1;
               
               if ((r>=1.0-m+0.1*m*(1-m) && r>0.2)|| (m==0 && r>0.8)) {
                  ArrowUp[i]=Open[i];
                  prevUp=Open[i];
                  nup++;
               }
            }
            if (TrendDn[i+1]>0 && TrendDn[i+2]>0 && ndn<Nmax && TrendDn[i+1]<TrendDn[i+2] &&
                ArrowDn[i+1]==0 && ArrowDn[i+2]==0 && ArrowDn[i+3]==0) {

               //  
               m=(prevDn-Open[i])/s0/Mmax;
               if (m<0) m=0;
               if (m>1) m=1;
               
               r=0.5+(-TrendDn[i+1]+Open[i])/s0/Rmax/2.0;
               if (r<0) r=0;
               if (r>1) r=1;
               
               if ((r>=1-m+0.1*m*(1-m) && r>0.2) || (m==0 && r>0.8)) {
                  ArrowDn[i]=Open[i];
                  prevDn=Open[i];
                  ndn++;
               }
            }
          }
      }
      
      return(0);
  }
//+------------------------------------------------------------------+



